'''A simple script that reads in a rosbag containing Kinect PC2 data and 
saves the PC2's as mrol point cloud files.

Takes source bag file path as an argument.

Saves files as 'mrolpcTIMESTAMP.dat' or 'mrolpcTIMESTAMP.npy'
'''
import roslib
roslib.load_manifest('mrol-mapping-ros-pkg')
import rospy
import numpy as np
from sensor_msgs.msg import LaserScan
from sensor_msgs.msg import PointCloud2
from sensor_msgs.msg import PointField
import tf
import rosbag
import mrol_mapping.pointcloud as pointcloud
import sys
import rosutils_mrol.rosutils_mrol as rosutils


max_range = 2.5

if __name__ == '__main__':
    if '-h' in sys.argv or len(sys.argv) < 2:
        print __doc__
        sys.exit()
    text = '--text' in sys.argv
    bagfilename = sys.argv[1]
    bagfile = rosbag.Bag(bagfilename,'r')
    mrolPCbasename = 'mrolpc'
    for topic, msg, ts in bagfile.read_messages(topics='/kinect/depth/points2'):
        xyzs = rosutils.pc22xyzs(msg,max_range)
        filename = mrolPCbasename+str(ts.to_sec())
        if text:
            filename = filename+'.dat'
            pointcloud.save(filename,xyzs,text=True)
        else:
            pointcloud.save(filename,xyzs,)

